1e34d99de7e1c07bcf546738bfaf67545c9efa97
[xfstests-dev.git] / tests / generic / 112
1 #! /bin/bash
2 # FS QA Test No. 112
3 #
4 # fsx (AIO variant, based on 075)
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2005 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=0        # success is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     cd /
37     rm -rf $TEST_DIR/fsx.* $tmp.*
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43
44 _do_test()
45 {
46     _n="$1"
47     _param="$2"
48
49     out=$TEST_DIR/fsx
50     rm -rf $out
51     if ! mkdir $out
52     then
53         echo "    failed to mkdir $out"
54         status=1
55         exit
56     fi
57
58     _filter_param=`echo "$_param" | sed\
59         -e 's/-N [0-9][0-9]*/-N numops/' \
60         -e 's/-l [0-9][0-9]*/-l filelen/'`
61
62     echo ""
63     echo "-----------------------------------------------"
64     echo "fsx.$_n : $_filter_param"
65     echo "-----------------------------------------------"
66
67     if [ "$FSTYP" != "xfs" ]
68     then
69         if [ "$_n" = "1" -o "$_n" = "3" ]
70         then
71             # HACK: only xfs handles preallocation (-x) so just skip this test
72             return
73         fi
74     fi
75
76     # This cd and use of -P gets full debug on $here (not TEST_DEV)
77     cd $out
78     if ! $here/ltp/fsx $_param -P $here $FSX_AVOID $seq.$_n &>/dev/null
79     then
80         echo "    fsx ($_param) returned $? - see $seq.$_n.full"
81         mv $seq.$_n.fsxlog $seqres.$_n.full
82         status=1
83         exit
84     fi
85
86     cd $here
87     _check_test_fs
88 }
89
90 _usage()
91 {
92     echo "$0: [-l filelen] [-n numops1] [-N numops2]"
93 }
94
95 _process_args()
96 {
97     while getopts "l:n:N:?" c $@
98     do
99         case $c
100         in
101             l)
102                 filelen=$OPTARG
103                 param_type="$param_type, overidde -l"
104                 ;;
105             N)
106                 numops2=$OPTARG
107                 param_type="$param_type, overidde -N"
108                 ;;
109             n)
110                 numops1=$OPTARG
111                 param_type="$param_type, overidde -n"
112                 ;;
113             ?)
114                 _usage
115                 exit    
116                 ;;
117         esac
118     done
119 }
120
121 # real QA test starts here
122 _supported_fs generic
123 _supported_os Linux
124
125 [ -x $here/ltp/aio-stress ] || \
126         _notrun "fsx not built with AIO for this platform"
127
128 size10=`expr 10 \* 1024 \* 1024`        # 10 megabytes
129 filelen=$size10
130 numops1=1000
131 numops2=10000
132
133 # can override the params here
134 _process_args "$@"
135
136 echo "Params are for $param_type" >>$seqres.full
137 echo "Params: n = $numops1 N = $numops2 l = $filelen" >>$seqres.full
138
139 rm -f $seqres.full
140 echo "brevity is wit..."
141
142 _check_test_fs
143
144 # Options:
145 # -d: debug output for all operations
146 # -l flen: the upper bound on file size (default 262144)
147 # -o oplen: the upper bound on operation size
148 # -N numops: total # operations to do (default infinity)
149 # -P: save .fsxlog and .fsxgood files in dirpath (default ./)
150 # -S seed: for random # generator (default 1) 0 gets timestamp
151 # -x: pre-allocate file space, exercising unwritten extents
152 # -A: use the AIO system calls
153
154 _do_test 0 "-A -d -N $numops1 -S 0"
155 _do_test 1 "-A -d -N $numops1 -S 0 -x"
156 _do_test 2 "-A -d -N $numops2 -l $filelen -S 0"
157 _do_test 3 "-A -d -N $numops2 -l $filelen -S 0 -x"
158
159 rm -f $seq.*.fsx{good,log}
160 exit 0